unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ShellAPI;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    function GetDiskSize(Root: string): LongInt;
    function GetFreeDiskSize(Root: string): LongInt;
    function GetDriveTypeStr(Root: string): string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.GetFreeDiskSize(Root: string): LongInt;
var
  SpC, BpS, NfC, TnC: DWORD;
  FreeDiskSize: Double;
begin
  GetDiskFreeSpace(PChar(Root), SpC, BpS, NfC, TnC);
  FreeDiskSize := (NfC * SpC * BpS) / 1024;
  Result := Round(FreeDiskSize);
end;

function TForm1.GetDiskSize(Root: string): LongInt;
var
  SpC, BpS, NfC, TnC: DWORD;
  FreeDiskSize: Double;
begin
  GetDiskFreeSpace(PChar(Root), SpC, BpS, NfC, TnC);
  FreeDiskSize := (TnC * SpC * BpS) / 1024;
  Result := Round(FreeDiskSize);
end;

function TForm1.GetDriveTypeStr(Root: string): string;
var
 DrvType: Integer;
begin
 DrvType := GetDriveType(PChar(Root));
  case DrvType of
    0: Result := '  ';
    1: Result := '';
    DRIVE_REMOVABLE: Result := ' ';
    DRIVE_FIXED: Result := 'Ƹ';
    DRIVE_REMOTE: Result := '';
    DRIVE_CDROM: Result := 'CD-ROM';
    DRIVE_RAMDISK: Result := 'RAM';
   end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
 shInfo: TSHFileInfo;
 NewItem: TListItem;
 i: Integer;
 DiskType: Integer;
 DiskSize,
 FreeSize: Integer;
 Drv: Char;
 drives: set of 0..25;
begin
 Integer(Drives) := GetLogicalDrives;
 for i := 0 to 25 do
  if (i in Drives) then
   begin
    Drv := Char(i + Ord('A'));
    NewItem := ListView1.Items.Add;
     try
      SHGetFileInfo(PChar(Drv + ':\'), 0, shInfo, SizeOf(shInfo),
        SHGFI_SYSICONINDEX or SHGFI_DISPLAYNAME or SHGFI_TYPENAME);
      NewItem.Caption := StrPas(shInfo.szDisplayName);
      DiskType := GetDriveType(PChar(Drv + ':\'));
      NewItem.SubItems.Add(GetDriveTypeStr(Drv + ':\'));
      if (DiskType <> DRIVE_REMOVABLE) and (DiskType <> DRIVE_CDROM) then
       begin
	DiskSize := GetDiskSize(Drv + ':\');
	FreeSize := GetFreeDiskSize(Drv + ':\');
       end
      else
       begin
        DiskSize := 0;
	FreeSize := 0;
       end;
      if DiskSize > 0 then
       NewItem.SubItems.Add(FormatFloat('###,###,### Mb', DiskSize div 1000))
      else NewItem.SubItems.Add('0 Mb');
      if FreeSize > 0 then
       NewItem.SubItems.Add(FormatFloat('###,###,### Mb', FreeSize div 1000))
      else NewItem.SubItems.Add('0 Mb');
       NewItem.SubItems.Add('');
      NewItem.SubItems.Add(Drv + ':\');
      NewItem.SubItems.Add('drv');
     except
      ListView1.Items.Delete(NewItem.Index);
     end;
   end;
end;

end.
